<?php

//namespace Simple\SHM;

class ShmOp
{
    protected $id;	
    protected $shmid;	
    protected $size = 102400;	
    protected $perms = 0666;
	protected $_handlers = array();
	
    public function __construct($id = null)
    {
        if($id === null) $this->id = $this->generateID();
        else $this->id = $id;
		//if($this->exists($this->id)) $this->shmid = shmop_open($this->id, "w", 0, 0);
    }
	
    protected function generateID()
    {
        $id = mt_rand(100, 65535);
        return $id;
    }
	
    protected function exists($id)
    {
        $status = @shmop_open($id, "a", 0, 0);

        return $status;
    }

    protected function write($data)
    {
		$data = serialize($data);
        if($this->exists($this->id)){
			$this->shmid = shmop_open($this->id, "w", $this->perms, $this->size);
            shmop_write($this->shmid, $data, 0);
        } else {
            $this->shmid = shmop_open($this->id, "c", $this->perms, $this->size);
            shmop_write($this->shmid, $data, 0);
        }
		shmop_close($this->shmid);
    }	
	
    public function read()
    {
        $this->shmid = shmop_open($this->id, "w", 0, 0);
		//$size = shmop_size($this->shmid);
        $data = shmop_read($this->shmid, 0, 0);
        $data = unserialize($data);
		shmop_close($this->shmid);
		
        return $data;
    }
	
    public function delete()
    {        		
		if($this->exists($this->id))
		{
		  $this->shmid = shmop_open($this->id, "w", 0, 0);
		  shmop_delete($this->shmid);
		  shmop_close($this->shmid);
		}
		
    }
	
    public function getId()
    {
        return $this->id;
    }
	
	/*
    public function getPermissions()
    {
        return $this->perms;
    }
	
    public function setPermissions($perms)
    {
        $this->perms = $perms;
    }
	*/
	
	public function push($event, $data = null)
	{			
		if($this->exists($this->id)) $storage_read = $this->read();
		if(is_array($storage_read)) $storage = $storage_read;
		else $storage = array();
		$c_time = time();
		$storage[$event] = array('time' => $c_time, 'data' => $data);
		$storage['_updated'] = $c_time;
		$this->write($storage);
		return $this->id;
	}
	
	public function listen($lastQueryTime = null)
	{
		$lastQueryTime = ($lastQueryTime) ?: time();
		$endTime = time() + (int) ini_get('max_execution_time') - 5;
		$result = array();
		if($this->exists($this->id)){
			while(time() < $endTime){
				//sleep(1);				
				$storage = $this->read();
				if ($storage['_updated'] < $lastQueryTime) continue;
				foreach ($storage as $event => $data) {
					if (substr($event, 0, 1) != '_' && $data['time'] > $lastQueryTime) {
						$ret = $this->_runHandler($event, $data['data']);
						if($ret){
							$result[$event] = $ret;
						}
					}
				}
				break;								
			}			
		}
		return $result;
	}
	
	public function registerEvent($event, $callback)
	{
		$this->_handlers[$event] = $callback;
	}
	
	protected function _runHandler($key, $data = array())
	{
		if(!empty($this->_handlers[$key])){
			return call_user_func_array($this->_handlers[$key], array($data));
		}
	}

    public function __destruct()
    {
        //shmop_close($this->shmid);
		//else echo 'NO sector to destructing close';
    }
}
?>