<?php
if(!defined('PESTUN')) die(' ');
class SimpleImage {
 
   var $image;
   var $image_type;
   var $image_info;
 
   function load($filename,$w) {
      global $config;
	  $image_info = getimagesize($filename);
      $t = $image_info[2];
      if( $t == IMAGETYPE_JPEG ) {
         $this->image = imagecreatefromjpeg($filename);
		 $this->image_type = 'jpg';
		 header('content-type: image/jpeg');
      } elseif( $t == IMAGETYPE_GIF ) {
         $this->image = imagecreatefromgif($filename);
		 $this->image_type = 'gif';
		 header('content-type: image/gif');
      } elseif( $t == IMAGETYPE_PNG ) {
         $this->image = imagecreatefrompng($filename);
		 $this->image_type = 'png';
		 header('content-type: image/png');
      }
	  if($config['watermark']=='1' && $w!==false){
	    $watermark = imagecreatefrompng($_SERVER['DOCUMENT_ROOT'].'/uploads/watermark.png');
	    $watermark_width = imagesx($watermark);
	    $watermark_height = imagesy($watermark);
	    $watermark_new_width = $this->getWidth() / 2;
	      if($watermark_new_width > $watermark_width)	    $watermark_new_height = $watermark_height * ($watermark_new_width/$watermark_width);
	      else if($watermark_new_width < $watermark_width)	    $watermark_new_height = $watermark_height / ($watermark_width/$watermark_new_width);
	      elseif($watermark_new_width == $watermark_width)  $watermark_new_height = $watermark_height;
	    $wm = imagecreatetruecolor($watermark_new_width, $watermark_new_height);
	    imagecolortransparent($wm, imagecolorallocatealpha($wm, 0, 0, 0, 127));
	    imagealphablending($wm, false);
	    imagesavealpha($wm, true);
	    imagecopyresampled($wm,$watermark,0,0,0,0,$watermark_new_width,$watermark_new_height, $watermark_width, $watermark_height);
	    imagecopy($this->image, $wm, $this->getWidth() - $watermark_new_width - 5, $this->getHeight() - $watermark_new_height - 5, 0, 0, $watermark_new_width, $watermark_new_height);
	  }
   }
   function save($filename, $compression=95, $permissions=null) {	  
	  if( $this->image_type == 'jpg' ) {
         imagejpeg($this->image,$filename,$compression);
      } else if( $this->image_type == 'gif' ) {
         imagegif($this->image,$filename);
      } else if( $this->image_type == 'png' ) {
         imagepng($this->image,$filename);
      }
      if( $permissions != null) {
         chmod($filename,$permissions);
      }	  
   }
   function output() {
      if( $this->image_type == 'jpg' ) {
         imagejpeg($this->image);
      } else if( $this->image_type == 'gif' ) {
         imagegif($this->image);
      } else if( $this->image_type == 'png' ) {
         imagepng($this->image);
      }
   }
   function getWidth() {
      return imagesx($this->image);
   }
   function getHeight() {
      return imagesy($this->image);
   }
   function resizeToHeight($height) {
      $ratio = $height / $this->getHeight();
      $width = $this->getWidth() * $ratio;
      $this->resize($width,$height);
   }
   function resizeToWidth($width) {
      $ratio = $width / $this->getWidth();
      $height = $this->getheight() * $ratio;
      $this->resize($width,$height);
   }
   function scale($scale) {
      $width = $this->getWidth() * $scale/100;
      $height = $this->getheight() * $scale/100;
      $this->resize($width,$height);
   }   
   function resize($width,$height) {
	  $new_image = imagecreatetruecolor($width, $height);
	  imagealphablending($new_image, false);
	  imagesavealpha($new_image, true);	
      imagecopyresampled($new_image, $this->image, 0, 0, 0, 0, $width, $height, $this->getWidth(), $this->getHeight());	  	  
	  $this->image = $new_image;	  
   }
}
?>